require "import"
import "com.androlua.*"
import "java.util.Locale"
import "android.net.Uri"
import "android.text.Html"

local translationResult = ""

-- Determine the source language based on device locale
local sourceLanguage = Locale.getDefault().getLanguage()

-- Set the target language to Punjabi
local targetLanguage = "pa"

-- Prepare the URL for translation using Google Translate
url = "https://translate.google.com/m?sl="..sourceLanguage.."&tl="..targetLanguage.."&q="..Uri.encode(this.getText(node))

-- Retrieve translation using HTTP request
Http.get(url, function(status, result)
    if status == 200 then
        -- Extract the translation and clean it from HTML
        local translation = tostring(Html.fromHtml(result:match('<div class="result%-container">([^<]+)</div>')))
        translationResult = translationResult .. translation
        service.setText(translationResult)

        -- Set the translated text
        service.speak("ਪਾਠ ਦਾ ਪੰਜਾਬੀ ਵਿੱਚ ਅਨੁਵਾਦ ਕੀਤਾ ਗਿਆ ਹੈ। ਅਨੁਵਾਦਿਤ ਪਾਠ ਹੈ" .. translationResult)

        -- Play a sound indicating the completion
        service.playSoundTick()
    end
end)
